<?php
/*
  =====================================================
  Модуль "Редиректы" для DLE
  -----------------------------------------------------
  http://hostdev.pw/
  -----------------------------------------------------
  Copyright (c) 20015 Евгений Паникаровский
  =====================================================
  Данный код защищен авторскими правами
  =====================================================
  Файл: redirects.php
  -----------------------------------------------------
  Назначение: Управление редиректами
  =====================================================
 */

if (!defined('DATALIFEENGINE') OR !defined('LOGGED_IN')) {
	die("Hacking attempt!");
}

echoheader("Редиректы", $lang['admin_redirect_header_text']);

$content = '';

$scriptname = $_SERVER['PHP_SELF'];
$row = $db->super_query("SELECT SQL_CALC_FOUND_ROWS * FROM " . PREFIX . "_admin_sections WHERE name = 'redirects' LIMIT 1");
if (is_null($row)) {
	if (isset($_POST['no_install'])) {
		ob_end_clean();
		header('Location: ');
		die();
	}
	if (isset($_POST['install'])) {
		$db->super_query("INSERT INTO `" . PREFIX . "_admin_sections` (`name`, `title`, `descr`, `icon`, `allow_groups`) VALUES ('redirects', 'Редиректы', 'Модуль позволяет управлять редиректами', 'redirects.png', '1');");
		$db->super_query("DROP TABLE IF EXISTS `" . PREFIX . "_redirects`;");
		$db->super_query("CREATE TABLE `" . PREFIX . "_redirects` (`id` SMALLINT(6) NOT NULL AUTO_INCREMENT,`old_url` VARCHAR(255) NOT NULL,`new_url` TINYTEXT NOT NULL,`active` TINYINT(1) NOT NULL DEFAULT '1',PRIMARY KEY (`id`),UNIQUE INDEX `old_url` (`old_url`))COLLATE='utf8_general_ci'ENGINE=MyISAM;");
		$db->super_query("INSERT INTO `" . PREFIX . "_redirects` (`old_url`, `new_url`, `active`) VALUES ('/old_url/', '/new_url/', 1);
");
		ob_end_clean();
		header("Location: {$scriptname}?mod=redirects");
		die();
	}
	?>
	<form method="post">
		<div style="padding-top:5px;padding-bottom:2px;">
			<table width="100%">
			  <tbody>
				<tr>
				  <td width="4">
					<img src="engine/skins/images/tl_lo.gif" width="4" height="4" border="0">
				  </td>
				  <td background="engine/skins/images/tl_oo.gif">
					<img src="engine/skins/images/tl_oo.gif" width="1" height="4" border="0">
				  </td>
				  <td width="6">
					<img src="engine/skins/images/tl_ro.gif" width="6" height="4" border="0">
				  </td>
				</tr>
				<tr>
				  <td background="engine/skins/images/tl_lb.gif">
					<img src="engine/skins/images/tl_lb.gif" width="4" height="1" border="0">
				  </td>
				  <td style="padding:5px;" bgcolor="#FFFFFF">
					<table width="100%">
					  <tbody>
						<tr>
						  <td bgcolor="#EFEFEF" height="29" style="padding-left:10px;">
							<div class="navigation">Установка модуля "Редиректы"</div>
						  </td>
						</tr>
					  </tbody>
					</table>
					<div class="unterline"></div>
					<table width="100%">
					  <tbody>
						<tr>
						  <td style="padding:2px;" height="100" align="center">Вы уверены, что хотите установить модуль "Редиректы"?
							<br>
							<br>
							<input class="btn btn-success" type="submit" value="  Да  " name="install">			
							<input type="button" class="btn btn-danger" value="  Нет  " name="no_install">
						  </td>
						</tr>
					  </tbody>
					</table>
				  </td>
				  <td background="engine/skins/images/tl_rb.gif">
					<img src="engine/skins/images/tl_rb.gif" width="6" height="1" border="0">
				  </td>
				</tr>
				<tr>
				  <td>
					<img src="engine/skins/images/tl_lu.gif" width="4" height="6" border="0">
				  </td>
				  <td background="engine/skins/images/tl_ub.gif">
					<img src="engine/skins/images/tl_ub.gif" width="1" height="6" border="0">
				  </td>
				  <td>
					<img src="engine/skins/images/tl_ru.gif" width="6" height="6" border="0">
				  </td>
				</tr>
			  </tbody>
			</table>
		</div>
	</form>
		<?php
	die();
}
?>
<style>
	body {
		cursor: default;
	}
	
	.redirects .btn {
		background: #7abcff;
		background: -moz-linear-gradient(top,  #7abcff 0%, #60abf8 44%, #4096ee 100%);
		background: -webkit-gradient(linear, left top, left bottom, color-stop(0%,#7abcff), color-stop(44%,#60abf8), color-stop(100%,#4096ee));
		background: -webkit-linear-gradient(top,  #7abcff 0%,#60abf8 44%,#4096ee 100%);
		background: -o-linear-gradient(top,  #7abcff 0%,#60abf8 44%,#4096ee 100%);
		background: -ms-linear-gradient(top,  #7abcff 0%,#60abf8 44%,#4096ee 100%);
		background: linear-gradient(to bottom,  #7abcff 0%,#60abf8 44%,#4096ee 100%);
		filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='#7abcff', endColorstr='#4096ee',GradientType=0 );
		color:#fff;
		height:29px;
		line-height:29px;
		padding: 0px 8px;
		white-space: nowrap;
		text-shadow: #000 0px 1px 0px;
		border-radius:0px;
		display:inline-block;
	}
	
	.redirects .btn.btn-danger {
		background: #ff3019;
		background: -moz-linear-gradient(top,  #ff3019 0%, #cf0404 100%);
		background: -webkit-gradient(linear, left top, left bottom, color-stop(0%,#ff3019), color-stop(100%,#cf0404));
		background: -webkit-linear-gradient(top,  #ff3019 0%,#cf0404 100%);
		background: -o-linear-gradient(top,  #ff3019 0%,#cf0404 100%);
		background: -ms-linear-gradient(top,  #ff3019 0%,#cf0404 100%);
		background: linear-gradient(to bottom,  #ff3019 0%,#cf0404 100%);
		filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='#ff3019', endColorstr='#cf0404',GradientType=0 );
	}

	.actions {
		text-align: center;
	}
	.actions a {
		display: inline-block;
		margin: 0 5px;
		height: 16px;
		color:#369;
	}

	.actions a.del {
		color:#e00;
	}
	
	.toolbar-link .add {
		color: #0b0;
		line-height: 35px;
	}
</style>

<?php
if (isset($_GET['edit'])) {
	$id = intval($_GET['edit']);

	if ($id <= 0) {
		ob_end_clean();
		msg("error", 'Неверный идентификатор редиректа', 'Ошибка! Указан неверный идентификатор редиректа для редактирования', "{$scriptname}?mod=redirects");
	} else {
		$db->query("SELECT SQL_CALC_FOUND_ROWS * FROM " . PREFIX . "_redirects WHERE id = {$id} LIMIT 1");
		if ($db->num_rows() > 0) {
			if (isset($_POST['save_redirect'])) {
				$old_url = $db->safesql($_POST['old_url']);
				$new_url = $db->safesql($_POST['new_url']);
				if ($old_url == $new_url) {
					ob_end_clean();
					msg("error", 'Ошибка добавления редиректа', 'Новый адрес не может быть равен старому адресу', "javascript:history.go(-1)");
				}
				$db->query("SELECT * FROM " . PREFIX . "_redirects WHERE id != {$id} and old_url = '{$old_url}' LIMIT 1");
				if ($db->num_rows() > 0) {
					ob_end_clean();
					msg("error", 'Редирект существует', 'Редирект с указанным адресом уже существует', "javascript:history.go(-1)");
				}
				$db->query("SELECT * FROM " . PREFIX . "_redirects WHERE old_url = '{$new_url}' LIMIT 1");
				if ($db->num_rows() > 0) {
					ob_end_clean();
					msg("error", 'Ошибка добавления редиректа', 'Новый адрес редиректа конфликтует с уже существующим редиректом', "javascript:history.go(-1)");
				}
				$active = (isset($_POST['active'])) ? 1 : 0;
				$db->query("UPDATE " . PREFIX . "_redirects set `old_url` = '{$old_url}', `new_url` = '{$new_url}', `active` = {$active} WHERE id = {$id} LIMIT 1");
				ob_end_clean();
				msg("info", 'Редирект изменен', 'Редирект успешно изменен', "{$scriptname}?mod=redirects");
			}
			$row = $db->get_row();
			?>
			<form method="post" class="form-horizontal">
				<div style="padding-top:5px;padding-bottom:2px;" class="redirects">
					<table width="100%">
						<tr>
						  <td width="4">
							<img src="engine/skins/images/tl_lo.gif" width="4" height="4" border="0">
						  </td>
						  <td background="engine/skins/images/tl_oo.gif">
							<img src="engine/skins/images/tl_oo.gif" width="1" height="4" border="0">
						  </td>
						  <td width="6">
							<img src="engine/skins/images/tl_ro.gif" width="6" height="4" border="0">
						  </td>
						</tr>
						<tr>
						  <td background="engine/skins/images/tl_lb.gif"><img src="engine/skins/images/tl_lb.gif" width="4" height="1" border="0"></td>
						  <td style="padding:5px;" bgcolor="#FFFFFF">
							<table width="100%">
							  <tbody>
								<tr>
								  <td bgcolor="#EFEFEF" height="29" style="padding-left:10px;">
									<div class="navigation">Редактирование редиректа</div>
								  </td>
								  <td bgcolor="#ccffcc" height="29" width="80"><a href="<?php echo $scriptname?>?mod=redirects" class="btn add">Список редиректов</a></td>
								</tr>
							  </tbody>
							</table>
							<div class="unterline"></div>
							<table width="100%">
							  <tbody>
								<tr>
								  <td width="140" height="29" style="padding-left:5px;">Старый адрес:</td>
								  <td>
									<input class="edit bk" type="text" style="width:350px;" name="old_url" id="old_url" value="<?php echo $row['old_url']; ?>" required/>
								  </td>
								</tr>
								<tr>
								  <td width="140" height="29" style="padding-left:5px;">Новый адрес:</td>
								  <td>
									<input class="edit bk" type="text" style="width:350px;" name="new_url" id="new_url" value="<?php echo $row['new_url']; ?>" required/>
								  </td>
								</tr>
								<tr>
								  <td colspan="2">
									<input class="icheck" type="checkbox" name="active" id="active" value="1" <?php if ($row['active'] == 1) echo 'checked'; ?>><label for="active">Редирект активен</label>
								  </td>
								</tr>
								<tr>
								  <td colspan="2"><br/>
									<input type="submit" value="Сохранить" name="save_redirect" class="btn btn-success">
								  </td>
								</tr>
							  </tbody>
							</table>
						  </td>
						   <td background="engine/skins/images/tl_rb.gif"><img src="engine/skins/images/tl_rb.gif" width="4" height="1" border="0"></td>
						</tr>
						<tr>
						  <td>
							<img src="engine/skins/images/tl_lu.gif" width="4" height="6" border="0">
						  </td>
						  <td background="engine/skins/images/tl_ub.gif">
							<img src="engine/skins/images/tl_ub.gif" width="1" height="6" border="0">
						  </td>
						  <td>
							<img src="engine/skins/images/tl_ru.gif" width="6" height="6" border="0">
						  </td>
						</tr>
					</table>
				</div>
			</form>
			<?php
		} else {
			ob_end_clean();
			msg("error", 'Редирект не существует', 'Ошибка! Указанного редиректа не существует', "{$scriptname}?mod=redirects");
		}
	}
} elseif (isset($_GET['add'])) {
	if (isset($_POST['save_redirect'])) {
		$old_url = $db->safesql($_POST['old_url']);
		$db->query("SELECT * FROM " . PREFIX . "_redirects WHERE old_url = '{$old_url}' LIMIT 1");
		if ($db->num_rows() > 0) {
			ob_end_clean();
			msg("error", 'Ошибка добавления редиректа', 'Редирект с указанным адресом уже существует', "javascript:history.go(-1)");
		}
		$db->query("SELECT * FROM " . PREFIX . "_redirects WHERE old_url = '{$new_url}' LIMIT 1");
		if ($db->num_rows() > 0) {
			ob_end_clean();
			msg("error", 'Ошибка добавления редиректа', 'Новый адрес редиректа конфликтует с уже существующим редиректом', "javascript:history.go(-1)");
		}
		$new_url = $db->safesql($_POST['new_url']);
		if ($old_url == $new_url) {
			ob_end_clean();
			msg("error", 'Ошибка добавления редиректа', 'Новый адрес не может быть равен старому адресу', "javascript:history.go(-1)");
		}
		$active = (isset($_POST['active'])) ? 1 : 0;
		$db->query("INSERT INTO " . PREFIX . "_redirects (`old_url`, `new_url`, `active`) VALUES ('{$old_url}', '{$new_url}', {$active} )");
		ob_end_clean();
		msg("info", 'Редирект добавлен', 'Редирект успешно добавлен', "{$scriptname}?mod=redirects");
	}
	?>
	<form method="post" class="form-horizontal">
		<div style="padding-top:5px;padding-bottom:2px;" class="redirects">
			<table width="100%">
				<tr>
				  <td width="4">
					<img src="engine/skins/images/tl_lo.gif" width="4" height="4" border="0">
				  </td>
				  <td background="engine/skins/images/tl_oo.gif">
					<img src="engine/skins/images/tl_oo.gif" width="1" height="4" border="0">
				  </td>
				  <td width="6">
					<img src="engine/skins/images/tl_ro.gif" width="6" height="4" border="0">
				  </td>
				</tr>
				<tr>
				  <td background="engine/skins/images/tl_lb.gif"><img src="engine/skins/images/tl_lb.gif" width="4" height="1" border="0"></td>
				  <td style="padding:5px;" bgcolor="#FFFFFF">
					<table width="100%">
					  <tbody>
						<tr>
						  <td bgcolor="#EFEFEF" height="29" style="padding-left:10px;">
							<div class="navigation">Добавление редиректа</div>
						  </td>
						  <td bgcolor="#ccffcc" height="29" width="80"><a href="<?php echo $scriptname?>?mod=redirects" class="btn add">Список редиректов</a></td>
						</tr>
					  </tbody>
					</table>
					<div class="unterline"></div>
					<table width="100%">
					  <tbody>
						<tr>
						  <td width="140" height="29" style="padding-left:5px;">Старый адрес:</td>
						  <td>
							<input class="edit bk" type="text" style="width:350px;" name="old_url" id="old_url" required/>
						  </td>
						</tr>
						<tr>
						  <td width="140" height="29" style="padding-left:5px;">Новый адрес:</td>
						  <td>
							<input class="edit bk" type="text" style="width:350px;" name="new_url" id="new_url" required/>
						  </td>
						</tr>
						<tr>
						  <td colspan="2">
							<input class="icheck" type="checkbox" name="active" id="active" value="1" checked><label for="active">Редирект активен</label>
						  </td>
						</tr>
						<tr>
						  <td colspan="2"><br/>
							<input type="submit" value="Сохранить" name="save_redirect" class="btn btn-success">
						  </td>
						</tr>
					  </tbody>
					</table>
				  </td>
				   <td background="engine/skins/images/tl_rb.gif"><img src="engine/skins/images/tl_rb.gif" width="4" height="1" border="0"></td>
				</tr>
				<tr>
				  <td>
					<img src="engine/skins/images/tl_lu.gif" width="4" height="6" border="0">
				  </td>
				  <td background="engine/skins/images/tl_ub.gif">
					<img src="engine/skins/images/tl_ub.gif" width="1" height="6" border="0">
				  </td>
				  <td>
					<img src="engine/skins/images/tl_ru.gif" width="6" height="6" border="0">
				  </td>
				</tr>
			</table>
		</div>
	</form>
	<?php
} elseif ($_GET['delete']) {
	if (isset($_POST['nosubmit_del'])) {
		ob_end_clean();
		header("Location: {$scriptname}?mod=redirects");
		die();
	}
	if (isset($_POST['submit_del'])) {
		$id = intval($_GET['delete']);
		$db->query("SELECT SQL_CALC_FOUND_ROWS * FROM " . PREFIX . "_redirects WHERE id = {$id} LIMIT 1");
		if ($db->num_rows() > 0) {
			$db->query("DELETE FROM " . PREFIX . "_redirects WHERE id='{$id}'");
			ob_end_clean();
			msg("info", 'Внимание', 'Указанного редирект успешно удален', "{$scriptname}?mod=redirects");
		} else {
			ob_end_clean();
			msg("error", 'Ошибка удаления редиректа', 'Указанного редиректа не существует', "{$scriptname}?mod=redirects");
		}
	}
	?>
	<form method="post">
		<div style="padding-top:5px;padding-bottom:2px;">
			<table width="100%">
			  <tbody>
				<tr>
				  <td width="4">
					<img src="engine/skins/images/tl_lo.gif" width="4" height="4" border="0">
				  </td>
				  <td background="engine/skins/images/tl_oo.gif">
					<img src="engine/skins/images/tl_oo.gif" width="1" height="4" border="0">
				  </td>
				  <td width="6">
					<img src="engine/skins/images/tl_ro.gif" width="6" height="4" border="0">
				  </td>
				</tr>
				<tr>
				  <td background="engine/skins/images/tl_lb.gif">
					<img src="engine/skins/images/tl_lb.gif" width="4" height="1" border="0">
				  </td>
				  <td style="padding:5px;" bgcolor="#FFFFFF">
					<table width="100%">
					  <tbody>
						<tr>
						  <td bgcolor="#EFEFEF" height="29" style="padding-left:10px;">
							<div class="navigation">Удаление редиректов</div>
						  </td>
						</tr>
					  </tbody>
					</table>
					<div class="unterline"></div>
					<table width="100%">
					  <tbody>
						<tr>
						  <td style="padding:2px;" height="100" align="center">Вы уверены, что хотите удалить выбранный редирект?
							<br>
							<br>
							<input class="btn btn-success" type="submit" value="  Да  " name="submit_del">			
							<input type="button" class="btn btn-danger" value="  Нет  " name="nosubmit_del">
						  </td>
						</tr>
					  </tbody>
					</table>
				  </td>
				  <td background="engine/skins/images/tl_rb.gif">
					<img src="engine/skins/images/tl_rb.gif" width="6" height="1" border="0">
				  </td>
				</tr>
				<tr>
				  <td>
					<img src="engine/skins/images/tl_lu.gif" width="4" height="6" border="0">
				  </td>
				  <td background="engine/skins/images/tl_ub.gif">
					<img src="engine/skins/images/tl_ub.gif" width="1" height="6" border="0">
				  </td>
				  <td>
					<img src="engine/skins/images/tl_ru.gif" width="6" height="6" border="0">
				  </td>
				</tr>
			  </tbody>
			</table>
		</div>
	</form>
	<?php
} else {
	$db->query("SELECT SQL_CALC_FOUND_ROWS * FROM " . PREFIX . "_redirects ORDER BY id ASC");
	?>
	<div style="padding-top:5px;padding-bottom:2px;" class="redirects">
			<table width="100%">
			  <tbody>
				<tr>
				  <td width="4">
					<img src="engine/skins/images/tl_lo.gif" width="4" height="4" border="0">
				  </td>
				  <td background="engine/skins/images/tl_oo.gif">
					<img src="engine/skins/images/tl_oo.gif" width="1" height="4" border="0">
				  </td>
				  <td width="6">
					<img src="engine/skins/images/tl_ro.gif" width="6" height="4" border="0">
				  </td>
				</tr>
				<tr>
				  <td background="engine/skins/images/tl_lb.gif">
					<img src="engine/skins/images/tl_lb.gif" width="4" height="1" border="0">
				  </td>
				  <td style="padding:5px;" bgcolor="#FFFFFF">
					<table width="100%">
					  <tbody>
						<tr>
						  <td bgcolor="#EFEFEF" height="29" style="padding-left:10px;">
							<div class="navigation">Список редиректов</div>
						  </td>
						  <td bgcolor="#ccffcc" height="29" width="80"><a href="<?php echo $scriptname?>?mod=redirects&add" class="btn add">Добавить</a></td>
						</tr>
					  </tbody>
					</table>
					<div class="unterline"></div>
					<table width="100%">
						<tr class="thead"><th style="width:80px; text-align:center;">ID</th><th>Старый адрес</th><th>Новый адрес</th><th width="40" style="text-align: center;">Статус</th><th width="170" style="text-align: center;">Действия</th></tr>
							<tr class="tfoot hoverRow">
							  <th colspan="7">
								<div class="hr_line"></div>
							  </th>
							</tr>
							<?php
							if ($db->num_rows() > 0) {
								while ($row = $db->get_row()) {
									?>
									<tr>
										<td align="center"><?php echo $row['id'] ?></td>
										<td><?php echo $row['old_url'] ?></td>
										<td><?php echo $row['new_url'] ?></td>
										<td align="center"><?php if ($row['active'] == 1) {
											echo '<img src="engine/skins/images/led_on.png" width="16" height="16" border="0">';
										} else {
											echo '<img src="engine/skins/images/led_off.png" width="16" height="16" border="0">';
										} ?>
										</td>
										<td class="actions">
											<a class="btn" href="<?php echo $scriptname?>?mod=redirects&edit=<?php echo $row['id'] ?>">Правка</a>
											<a class="btn btn-danger" href="<?php echo $scriptname?>?mod=redirects&delete=<?php echo $row['id'] ?>">Удалить</a>
										</td>
									</tr>
									<?php
								}
							} else {
								?>
								<tr><td colspan="4" align="center">Редиректов нет</td></tr>
								<?php
							}
							?>
						</table>
					</td>
					<td background="engine/skins/images/tl_rb.gif">
						<img src="engine/skins/images/tl_rb.gif" width="6" height="1" border="0">
					</td>
				</tr>
				<tr>
				  <td>
					<img src="engine/skins/images/tl_lu.gif" width="4" height="6" border="0">
				  </td>
				  <td background="engine/skins/images/tl_ub.gif">
					<img src="engine/skins/images/tl_ub.gif" width="1" height="6" border="0">
				  </td>
				  <td>
					<img src="engine/skins/images/tl_ru.gif" width="6" height="6" border="0">
				  </td>
				</tr>
			</tbody>
		</table>

	</div>
	<?php
}

	echofooter();